#!/bin/sh
# create the files needed for the equilibrium compressed halo
compress << eof
0      # input from stdin
2      # number of components
y      # cmpnt 1 is a disk
exp    # disk type
1      # mass
1      # scale length
5      # truncation radius
none   # no DF (for now)
1.5    # initial Q
4.5    # inner edge of outer taper
n      # component 2 is not a disk
isot   # halo type
1      # axymptotic speed
5      # core radius
10.    # outer edge
eddi   # DF type
y      # OK to accept disk thickness
eof
ln -s compress.dat run300.cmp
# set up the DF for the disk and select particles
smooth << eof
1      # read the .dat file
300    # run number
1      # select component 1
y      # OK for all particles in component 2 to have the same mass
y      # OK for all particles in component 1 to have the same mass
400 100 25 # 1 million particles
y      # OK to accept change of mass fraction
eof
mv shue1000k.dfn run300.df1
# select particles from the halo DF
smooth << eof
1      # read the .dat file
300    # run number
2      # select component 2
400 100 25 # 1 million particles
y      # OK for all particles in component 2 to have the same mass
y      # OK to accept change of mass fraction
eof
mv comp1000k.dfn run300.df2
# set up the model
mkpcs << eof
300
y      # OK for all particles in component 1 to have the same mass
eof
# prepare to run
pcs2dmp << eof
300
0
eof
# evolve
galaxy << eof
300
0
eof
