      subroutine smfield( j )
c  Copyright (C) 2017, Jerry Sellwood
      use aarrays
      implicit none
c
c calling argument
      integer j
c
c common blocks
c
      include 'inc/params.f'
c
      include 'inc/admin.f'
c
      include 'inc/grids.f'
c
      include 'inc/model.f'
c
c externals
      real*8 meanph2, meanrf2, splint2
c
c local variables
      integer i, jcmp, k
      real*8 r, rs
c
      jcmp = icmp
      if( master )print *,
     +           'using the grid to compute the field of component', j
c initialize grid parameters etc
      call grdset
      call setrun
      if( .not. lgrd )call crash( 'SMFIELD', 'Not a grid' )
c create or check Greens function file for grid methods
      call greenm( .false. )
c allocate space
      call setspc
c assign mass to grids etc
      phys = .true.
      lprint = .true.
      dist( j ) = .false.
      call smmass
c determine gravitational field
      call findf( .true. )
c create and save tables of potential and central attraction
      k = -1
      call opnfil( k, 'ftb', 'unformatted', 'unknown', 'seq', i )
      if( i .ne. 0 )call crash( 'SMFIELD', 'open ftb file failed' )
      nradt = 1001
      if( .not. allocated( radt ) )allocate ( radt( nradt ) )
      if( .not. allocated( Phtt ) )allocate ( Phtt( nradt ) )
      if( .not. allocated( frtt ) )allocate ( frtt( nradt ) )
      do i = 1, nradt
        rs = .999 * rgrid( jgrid ) * real( i - 1 ) / real( nradt - 1 )
        r = rs / lscale
        radt( i ) = r
c these functions include contributions from rigid components
        Phtt( i ) = meanph2( rs, 0.d0 ) * gvfac**2
        frtt( i ) = meanrf2( rs ) / ( lscale * ts**2 )
      end do
      write( k )nradt
      write( k )radt, Phtt, frtt
      close( k )
      icmp = jcmp
c initialize splines
      if( .not. allocated( Pttlam ) )then
        allocate ( Pttlam( nradt + 4 ) )
        allocate ( Phttc( nradt + 4 ) )
      end if
      if( .not. allocated( fttlam ) )then
        allocate ( fttlam( nradt + 4 ) )
        allocate ( frttc( nradt + 4 ) )
      end if
      r = radt( nradt / 2 )
      rs = splint2( radt, Phtt, nradt, r, Pttlam, Phttc, .true. )
      rs = splint2( radt, frtt, nradt, r, fttlam, frttc, .true. )
      lgfld = .true.
      return
      end
